<template>
  <v-tooltip bottom>
    <template v-slot:activator="{ on, attrs }">
      <v-card tile flat v-bind="attrs" v-on="on">
        <v-card-title>{{ title }}</v-card-title>
        <v-card-subtitle :style="'color:' + colors[level]">{{
          subtitle
        }}</v-card-subtitle>
        <v-card-text class="text-center pa-0" style="font-size:30px">
          {{ value }}
          <v-expansion-panels accordion class="mt-2 pa-0" flat tile v-if="items && items[0]?.name">
            <v-expansion-panel>
              <v-expansion-panel-header class="pa-4"></v-expansion-panel-header>
              <v-expansion-panel-content
                style="font-size:11px; text-align:left"
              >
                <v-virtual-scroll :items="items" height="100" item-height="20">
                  <template v-slot:default="{ item }">
                    <div
                      style="cursor:pointer"
                      @click="$emit('searchFor', item.name)"
                    >
                      {{ item.name }}
                    </div>
                  </template>
                </v-virtual-scroll>
              </v-expansion-panel-content>
            </v-expansion-panel>
          </v-expansion-panels>
        </v-card-text>
        <v-card-actions v-if="items && items[0].comment">
          <v-spacer></v-spacer>
          <v-btn icon @click="showDialog(items)"><v-icon>mdi-plus</v-icon></v-btn>
        </v-card-actions>
      </v-card>
      <anomalies-details ref="anomalyStatsDialog" :items="currentDetail"></anomalies-details>
    </template>
    <span>{{ tooltip }}</span>
  </v-tooltip>
</template>

<script>
import AnomaliesDetails from './AnomaliesDetails.vue';

export default {
  name: "Stats",
  props: {
    title: { type: String, default: "Stats" },
    subtitle: { type: String, default: "Generic" },
    tooltip: { type: String, default: "" },
    value: { default: "-" },
    items: {
      type: Array,
      default: () => {
        return [{ name: "no item details" }];
      }
    },
    level: { type: Number, default: 0 }
  },
  data() {
    return {
      colors: ["black", "black", "black"],
      dialog: false,
      currentDetail: false,
      severityIcons: {
        'trace' : ['mdi-bug-check', 'black'],
        'debug' :['mdi-bug-outline', 'black'],
        'info' : ['mdi-information-outline', 'green'],
        'warn' :['mdi-alert', 'orange'],
        'error' :['mdi-alert-circle', 'red'],
        'fatal' :['mdi-alert-circle', 'red'],
      }
    };
  },
  methods: {
    showDialog(details) {
      this.currentDetail = details;
      this.$refs.anomalyStatsDialog.show(details);
    }
  }
};
</script>
